import{S as Na,i as Da,s as Ga,e as n,k as c,w as fe,t as s,M as Ha,c as r,d as a,m as u,a as i,x as pe,h as f,b as o,G as t,g as p,y as ce,L as La,q as ue,o as he,B as de,v as Ja}from"../chunks/vendor-hf-doc-builder.js";import{I as Xe}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as Za}from"../chunks/CodeBlock-hf-doc-builder.js";function Wa(na){let d,Ce,m,b,me,C,ot,_e,lt,Ue,Z,st,ke,_,g,Pe,U,ft,ve,pt,Me,W,ct,Se,Y,ut,Be,w,ht,k,dt,mt,Fe,P,x,Ee,M,_t,be,Pt,Ve,j,vt,qe,T,ge,S,O,Et,bt,Q,gt,wt,h,B,K,xt,Tt,ee,yt,At,F,te,$t,It,ae,Xt,Ct,V,ne,Ut,kt,re,Mt,St,q,ie,Bt,Ft,oe,Vt,Re,R,ze,y,qt,z,Rt,zt,Ne,v,A,we,N,Nt,xe,Dt,De,D,Gt,G,Ht,Ge,le,se,Lt,$,Jt,Te,Zt,Wt,ye,Yt,He,E,I,Ae,H,jt,$e,Ot,Le,L,Qt,J,Kt,Je;return C=new Xe({}),U=new Xe({}),M=new Xe({}),R=new Za({props:{code:"cGlwJTIwaW5zdGFsbCUyMGludGVsX2V4dGVuc2lvbl9mb3JfcHl0b3JjaCUzRCUzRCUzQ3ZlcnNpb25fbmFtZSUzRSUyMC1mJTIwaHR0cHMlM0ElMkYlMkZkZXZlbG9wZXIuaW50ZWwuY29tJTJGaXBleC13aGwtc3RhYmxlLWNwdQ==",highlighted:'pip install <span class="hljs-built_in">int</span>el_extension_for_pytorch==&lt;version_name&gt; -f https:<span class="hljs-comment">//developer.intel.com/ipex-whl-stable-cpu</span>'}}),N=new Xe({}),H=new Xe({}),{c(){d=n("meta"),Ce=c(),m=n("h1"),b=n("a"),me=n("span"),fe(C.$$.fragment),ot=c(),_e=n("span"),lt=s("Efficient Training on CPU"),Ue=c(),Z=n("p"),st=s("This guide focuses on training large models efficiently on CPU."),ke=c(),_=n("h2"),g=n("a"),Pe=n("span"),fe(U.$$.fragment),ft=c(),ve=n("span"),pt=s("Mixed precision with IPEX"),Me=c(),W=n("p"),ct=s("IPEX is optimized for CPUs with AVX-512 or above, and functionally works for CPUs with only AVX2. So, it is expected to bring performance benefit for Intel CPU generations with AVX-512 or above while CPUs with only AVX2 (e.g., AMD CPUs or older Intel CPUs) might result in a better performance under IPEX, but not guaranteed. IPEX provides performance optimizations for CPU training with both Float32 and BFloat16. The usage of BFloat16 is the main focus of the following sections."),Se=c(),Y=n("p"),ut=s("Low precision data type BFloat16 has been natively supported on the 3rd Generation Xeon\xAE Scalable Processors (aka Cooper Lake) with AVX512 instruction set and will be supported on the next generation of Intel\xAE Xeon\xAE Scalable Processors with Intel\xAE Advanced Matrix Extensions (Intel\xAE AMX) instruction set with further boosted performance. The Auto Mixed Precision for CPU backend has been enabled since PyTorch-1.10. At the same time, the support of Auto Mixed Precision with BFloat16 for CPU and BFloat16 optimization of operators has been massively enabled in Intel\xAE Extension for PyTorch, and partially upstreamed to PyTorch master branch. Users can get better performance and user experience with IPEX Auto Mixed Precision."),Be=c(),w=n("p"),ht=s("Check more detailed information for "),k=n("a"),dt=s("Auto Mixed Precision"),mt=s("."),Fe=c(),P=n("h3"),x=n("a"),Ee=n("span"),fe(M.$$.fragment),_t=c(),be=n("span"),Pt=s("IPEX installation:"),Ve=c(),j=n("p"),vt=s("IPEX release is following PyTorch, to install via pip:"),qe=c(),T=n("table"),ge=n("thead"),S=n("tr"),O=n("th"),Et=s("PyTorch Version"),bt=c(),Q=n("th"),gt=s("IPEX version"),wt=c(),h=n("tbody"),B=n("tr"),K=n("td"),xt=s("1.13"),Tt=c(),ee=n("td"),yt=s("1.13.0+cpu"),At=c(),F=n("tr"),te=n("td"),$t=s("1.12"),It=c(),ae=n("td"),Xt=s("1.12.300+cpu"),Ct=c(),V=n("tr"),ne=n("td"),Ut=s("1.11"),kt=c(),re=n("td"),Mt=s("1.11.200+cpu"),St=c(),q=n("tr"),ie=n("td"),Bt=s("1.10"),Ft=c(),oe=n("td"),Vt=s("1.10.100+cpu"),Re=c(),fe(R.$$.fragment),ze=c(),y=n("p"),qt=s("Check more approaches for "),z=n("a"),Rt=s("IPEX installation"),zt=s("."),Ne=c(),v=n("h3"),A=n("a"),we=n("span"),fe(N.$$.fragment),Nt=c(),xe=n("span"),Dt=s("Usage in Trainer"),De=s("\n\nTo enable auto mixed precision with IPEX in Trainer, users should add `use_ipex`, `bf16` and `no_cuda` in training command arguments.\n"),D=n("p"),Gt=s("Take an example of the use cases on "),G=n("a"),Ht=s("Transformers question-answering"),Ge=c(),le=n("ul"),se=n("li"),Lt=s("Training with IPEX using BF16 auto mixed precision on CPU:"),$=n("pre"),Jt=s(` python run_qa.py \\
--model_name_or_path bert-base-uncased \\
--dataset_name squad \\
--do_train \\
--do_eval \\
--per_device_train_batch_size 12 \\
--learning_rate 3e-5 \\
--num_train_epochs 2 \\
--max_seq_length 384 \\
--doc_stride 128 \\
--output_dir /tmp/debug_squad/ \\
`),Te=n("b"),Zt=s("--use_ipex \\"),Wt=s(`
`),ye=n("b"),Yt=s("--bf16 --no_cuda"),He=c(),E=n("h3"),I=n("a"),Ae=n("span"),fe(H.$$.fragment),jt=c(),$e=n("span"),Ot=s("Practice example"),Le=c(),L=n("p"),Qt=s("Blog: "),J=n("a"),Kt=s("Accelerating PyTorch Transformers with Intel Sapphire Rapids"),this.h()},l(e){const l=Ha('[data-svelte="svelte-1phssyn"]',document.head);d=r(l,"META",{name:!0,content:!0}),l.forEach(a),Ce=u(e),m=r(e,"H1",{class:!0});var Ze=i(m);b=r(Ze,"A",{id:!0,class:!0,href:!0});var ra=i(b);me=r(ra,"SPAN",{});var ia=i(me);pe(C.$$.fragment,ia),ia.forEach(a),ra.forEach(a),ot=u(Ze),_e=r(Ze,"SPAN",{});var oa=i(_e);lt=f(oa,"Efficient Training on CPU"),oa.forEach(a),Ze.forEach(a),Ue=u(e),Z=r(e,"P",{});var la=i(Z);st=f(la,"This guide focuses on training large models efficiently on CPU."),la.forEach(a),ke=u(e),_=r(e,"H2",{class:!0});var We=i(_);g=r(We,"A",{id:!0,class:!0,href:!0});var sa=i(g);Pe=r(sa,"SPAN",{});var fa=i(Pe);pe(U.$$.fragment,fa),fa.forEach(a),sa.forEach(a),ft=u(We),ve=r(We,"SPAN",{});var pa=i(ve);pt=f(pa,"Mixed precision with IPEX"),pa.forEach(a),We.forEach(a),Me=u(e),W=r(e,"P",{});var ca=i(W);ct=f(ca,"IPEX is optimized for CPUs with AVX-512 or above, and functionally works for CPUs with only AVX2. So, it is expected to bring performance benefit for Intel CPU generations with AVX-512 or above while CPUs with only AVX2 (e.g., AMD CPUs or older Intel CPUs) might result in a better performance under IPEX, but not guaranteed. IPEX provides performance optimizations for CPU training with both Float32 and BFloat16. The usage of BFloat16 is the main focus of the following sections."),ca.forEach(a),Se=u(e),Y=r(e,"P",{});var ua=i(Y);ut=f(ua,"Low precision data type BFloat16 has been natively supported on the 3rd Generation Xeon\xAE Scalable Processors (aka Cooper Lake) with AVX512 instruction set and will be supported on the next generation of Intel\xAE Xeon\xAE Scalable Processors with Intel\xAE Advanced Matrix Extensions (Intel\xAE AMX) instruction set with further boosted performance. The Auto Mixed Precision for CPU backend has been enabled since PyTorch-1.10. At the same time, the support of Auto Mixed Precision with BFloat16 for CPU and BFloat16 optimization of operators has been massively enabled in Intel\xAE Extension for PyTorch, and partially upstreamed to PyTorch master branch. Users can get better performance and user experience with IPEX Auto Mixed Precision."),ua.forEach(a),Be=u(e),w=r(e,"P",{});var Ye=i(w);ht=f(Ye,"Check more detailed information for "),k=r(Ye,"A",{href:!0,rel:!0});var ha=i(k);dt=f(ha,"Auto Mixed Precision"),ha.forEach(a),mt=f(Ye,"."),Ye.forEach(a),Fe=u(e),P=r(e,"H3",{class:!0});var je=i(P);x=r(je,"A",{id:!0,class:!0,href:!0});var da=i(x);Ee=r(da,"SPAN",{});var ma=i(Ee);pe(M.$$.fragment,ma),ma.forEach(a),da.forEach(a),_t=u(je),be=r(je,"SPAN",{});var _a=i(be);Pt=f(_a,"IPEX installation:"),_a.forEach(a),je.forEach(a),Ve=u(e),j=r(e,"P",{});var Pa=i(j);vt=f(Pa,"IPEX release is following PyTorch, to install via pip:"),Pa.forEach(a),qe=u(e),T=r(e,"TABLE",{});var Oe=i(T);ge=r(Oe,"THEAD",{});var va=i(ge);S=r(va,"TR",{});var Qe=i(S);O=r(Qe,"TH",{align:!0});var Ea=i(O);Et=f(Ea,"PyTorch Version"),Ea.forEach(a),bt=u(Qe),Q=r(Qe,"TH",{align:!0});var ba=i(Q);gt=f(ba,"IPEX version"),ba.forEach(a),Qe.forEach(a),va.forEach(a),wt=u(Oe),h=r(Oe,"TBODY",{});var X=i(h);B=r(X,"TR",{});var Ke=i(B);K=r(Ke,"TD",{align:!0});var ga=i(K);xt=f(ga,"1.13"),ga.forEach(a),Tt=u(Ke),ee=r(Ke,"TD",{align:!0});var wa=i(ee);yt=f(wa,"1.13.0+cpu"),wa.forEach(a),Ke.forEach(a),At=u(X),F=r(X,"TR",{});var et=i(F);te=r(et,"TD",{align:!0});var xa=i(te);$t=f(xa,"1.12"),xa.forEach(a),It=u(et),ae=r(et,"TD",{align:!0});var Ta=i(ae);Xt=f(Ta,"1.12.300+cpu"),Ta.forEach(a),et.forEach(a),Ct=u(X),V=r(X,"TR",{});var tt=i(V);ne=r(tt,"TD",{align:!0});var ya=i(ne);Ut=f(ya,"1.11"),ya.forEach(a),kt=u(tt),re=r(tt,"TD",{align:!0});var Aa=i(re);Mt=f(Aa,"1.11.200+cpu"),Aa.forEach(a),tt.forEach(a),St=u(X),q=r(X,"TR",{});var at=i(q);ie=r(at,"TD",{align:!0});var $a=i(ie);Bt=f($a,"1.10"),$a.forEach(a),Ft=u(at),oe=r(at,"TD",{align:!0});var Ia=i(oe);Vt=f(Ia,"1.10.100+cpu"),Ia.forEach(a),at.forEach(a),X.forEach(a),Oe.forEach(a),Re=u(e),pe(R.$$.fragment,e),ze=u(e),y=r(e,"P",{});var nt=i(y);qt=f(nt,"Check more approaches for "),z=r(nt,"A",{href:!0,rel:!0});var Xa=i(z);Rt=f(Xa,"IPEX installation"),Xa.forEach(a),zt=f(nt,"."),nt.forEach(a),Ne=u(e),v=r(e,"H3",{class:!0});var rt=i(v);A=r(rt,"A",{id:!0,class:!0,href:!0});var Ca=i(A);we=r(Ca,"SPAN",{});var Ua=i(we);pe(N.$$.fragment,Ua),Ua.forEach(a),Ca.forEach(a),Nt=u(rt),xe=r(rt,"SPAN",{});var ka=i(xe);Dt=f(ka,"Usage in Trainer"),ka.forEach(a),rt.forEach(a),De=f(e,"\n\nTo enable auto mixed precision with IPEX in Trainer, users should add `use_ipex`, `bf16` and `no_cuda` in training command arguments.\n"),D=r(e,"P",{});var ea=i(D);Gt=f(ea,"Take an example of the use cases on "),G=r(ea,"A",{href:!0,rel:!0});var Ma=i(G);Ht=f(Ma,"Transformers question-answering"),Ma.forEach(a),ea.forEach(a),Ge=u(e),le=r(e,"UL",{});var Sa=i(le);se=r(Sa,"LI",{});var ta=i(se);Lt=f(ta,"Training with IPEX using BF16 auto mixed precision on CPU:"),$=r(ta,"PRE",{});var Ie=i($);Jt=f(Ie,` python run_qa.py \\
--model_name_or_path bert-base-uncased \\
--dataset_name squad \\
--do_train \\
--do_eval \\
--per_device_train_batch_size 12 \\
--learning_rate 3e-5 \\
--num_train_epochs 2 \\
--max_seq_length 384 \\
--doc_stride 128 \\
--output_dir /tmp/debug_squad/ \\
`),Te=r(Ie,"B",{});var Ba=i(Te);Zt=f(Ba,"--use_ipex \\"),Ba.forEach(a),Wt=f(Ie,`
`),ye=r(Ie,"B",{});var Fa=i(ye);Yt=f(Fa,"--bf16 --no_cuda"),Fa.forEach(a),Ie.forEach(a),ta.forEach(a),Sa.forEach(a),He=u(e),E=r(e,"H3",{class:!0});var it=i(E);I=r(it,"A",{id:!0,class:!0,href:!0});var Va=i(I);Ae=r(Va,"SPAN",{});var qa=i(Ae);pe(H.$$.fragment,qa),qa.forEach(a),Va.forEach(a),jt=u(it),$e=r(it,"SPAN",{});var Ra=i($e);Ot=f(Ra,"Practice example"),Ra.forEach(a),it.forEach(a),Le=u(e),L=r(e,"P",{});var aa=i(L);Qt=f(aa,"Blog: "),J=r(aa,"A",{href:!0,rel:!0});var za=i(J);Kt=f(za,"Accelerating PyTorch Transformers with Intel Sapphire Rapids"),za.forEach(a),aa.forEach(a),this.h()},h(){o(d,"name","hf:doc:metadata"),o(d,"content",JSON.stringify(Ya)),o(b,"id","efficient-training-on-cpu"),o(b,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),o(b,"href","#efficient-training-on-cpu"),o(m,"class","relative group"),o(g,"id","mixed-precision-with-ipex"),o(g,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),o(g,"href","#mixed-precision-with-ipex"),o(_,"class","relative group"),o(k,"href","https://intel.github.io/intel-extension-for-pytorch/cpu/latest/tutorials/features/amp.html"),o(k,"rel","nofollow"),o(x,"id","ipex-installation"),o(x,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),o(x,"href","#ipex-installation"),o(P,"class","relative group"),o(O,"align","center"),o(Q,"align","center"),o(K,"align","center"),o(ee,"align","center"),o(te,"align","center"),o(ae,"align","center"),o(ne,"align","center"),o(re,"align","center"),o(ie,"align","center"),o(oe,"align","center"),o(z,"href","https://intel.github.io/intel-extension-for-pytorch/cpu/latest/tutorials/installation.html"),o(z,"rel","nofollow"),o(A,"id","usage-in-trainer"),o(A,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),o(A,"href","#usage-in-trainer"),o(v,"class","relative group"),o(G,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/question-answering"),o(G,"rel","nofollow"),o(I,"id","practice-example"),o(I,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),o(I,"href","#practice-example"),o(E,"class","relative group"),o(J,"href","https://huggingface.co/blog/intel-sapphire-rapids"),o(J,"rel","nofollow")},m(e,l){t(document.head,d),p(e,Ce,l),p(e,m,l),t(m,b),t(b,me),ce(C,me,null),t(m,ot),t(m,_e),t(_e,lt),p(e,Ue,l),p(e,Z,l),t(Z,st),p(e,ke,l),p(e,_,l),t(_,g),t(g,Pe),ce(U,Pe,null),t(_,ft),t(_,ve),t(ve,pt),p(e,Me,l),p(e,W,l),t(W,ct),p(e,Se,l),p(e,Y,l),t(Y,ut),p(e,Be,l),p(e,w,l),t(w,ht),t(w,k),t(k,dt),t(w,mt),p(e,Fe,l),p(e,P,l),t(P,x),t(x,Ee),ce(M,Ee,null),t(P,_t),t(P,be),t(be,Pt),p(e,Ve,l),p(e,j,l),t(j,vt),p(e,qe,l),p(e,T,l),t(T,ge),t(ge,S),t(S,O),t(O,Et),t(S,bt),t(S,Q),t(Q,gt),t(T,wt),t(T,h),t(h,B),t(B,K),t(K,xt),t(B,Tt),t(B,ee),t(ee,yt),t(h,At),t(h,F),t(F,te),t(te,$t),t(F,It),t(F,ae),t(ae,Xt),t(h,Ct),t(h,V),t(V,ne),t(ne,Ut),t(V,kt),t(V,re),t(re,Mt),t(h,St),t(h,q),t(q,ie),t(ie,Bt),t(q,Ft),t(q,oe),t(oe,Vt),p(e,Re,l),ce(R,e,l),p(e,ze,l),p(e,y,l),t(y,qt),t(y,z),t(z,Rt),t(y,zt),p(e,Ne,l),p(e,v,l),t(v,A),t(A,we),ce(N,we,null),t(v,Nt),t(v,xe),t(xe,Dt),p(e,De,l),p(e,D,l),t(D,Gt),t(D,G),t(G,Ht),p(e,Ge,l),p(e,le,l),t(le,se),t(se,Lt),t(se,$),t($,Jt),t($,Te),t(Te,Zt),t($,Wt),t($,ye),t(ye,Yt),p(e,He,l),p(e,E,l),t(E,I),t(I,Ae),ce(H,Ae,null),t(E,jt),t(E,$e),t($e,Ot),p(e,Le,l),p(e,L,l),t(L,Qt),t(L,J),t(J,Kt),Je=!0},p:La,i(e){Je||(ue(C.$$.fragment,e),ue(U.$$.fragment,e),ue(M.$$.fragment,e),ue(R.$$.fragment,e),ue(N.$$.fragment,e),ue(H.$$.fragment,e),Je=!0)},o(e){he(C.$$.fragment,e),he(U.$$.fragment,e),he(M.$$.fragment,e),he(R.$$.fragment,e),he(N.$$.fragment,e),he(H.$$.fragment,e),Je=!1},d(e){a(d),e&&a(Ce),e&&a(m),de(C),e&&a(Ue),e&&a(Z),e&&a(ke),e&&a(_),de(U),e&&a(Me),e&&a(W),e&&a(Se),e&&a(Y),e&&a(Be),e&&a(w),e&&a(Fe),e&&a(P),de(M),e&&a(Ve),e&&a(j),e&&a(qe),e&&a(T),e&&a(Re),de(R,e),e&&a(ze),e&&a(y),e&&a(Ne),e&&a(v),de(N),e&&a(De),e&&a(D),e&&a(Ge),e&&a(le),e&&a(He),e&&a(E),de(H),e&&a(Le),e&&a(L)}}}const Ya={local:"efficient-training-on-cpu",sections:[{local:"mixed-precision-with-ipex",sections:[{local:"ipex-installation",title:"IPEX installation:"},{local:"usage-in-trainer",title:"Usage in Trainer"},{local:"practice-example",title:"Practice example"}],title:"Mixed precision with IPEX"}],title:"Efficient Training on CPU"};function ja(na){return Ja(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class en extends Na{constructor(d){super();Da(this,d,ja,Wa,Ga,{})}}export{en as default,Ya as metadata};
