import{S as Ni,i as Ci,s as Ti,e as r,k as f,w as d,t as p,M as xi,c as i,d as t,m as u,a as n,x as g,h as c,b as l,N as Hi,G as a,g as o,y as v,q as _,o as P,B as $,v as Ii}from"../chunks/vendor-hf-doc-builder.js";import{T as Mi}from"../chunks/Tip-hf-doc-builder.js";import{I as E}from"../chunks/IconCopyLink-hf-doc-builder.js";function zi($t){let h,M;return{c(){h=r("p"),M=p("Note: Most of the strategies introduced in the single GPU sections (such as mixed precision training or gradient accumulation) are generic and apply to training models in general so make sure to have a look at it before diving into the following sections such as multi-GPU or CPU training.")},l(m){h=i(m,"P",{});var w=n(h);M=c(w,"Note: Most of the strategies introduced in the single GPU sections (such as mixed precision training or gradient accumulation) are generic and apply to training models in general so make sure to have a look at it before diving into the following sections such as multi-GPU or CPU training."),w.forEach(t)},m(m,w){o(m,h,w),a(h,M)},d(m){m&&t(h)}}}function qi($t){let h,M,m,w,Le,X,da,Je,ga,Et,ce,va,wt,he,me,or,bt,de,_a,yt,b,z,Oe,Y,Pa,je,$a,Ut,ge,Ea,kt,q,Gt,y,W,Fe,Z,wa,Ke,ba,At,ve,ya,St,_e,Pe,Ua,Nt,U,B,Qe,ee,ka,Ve,Ga,Ct,$e,Aa,Tt,Ee,we,Sa,xt,k,R,Xe,te,Na,Ye,Ca,Ht,be,ye,Ta,It,G,D,Ze,ae,xa,et,Ha,Mt,Ue,ke,tt,Ia,zt,A,L,at,re,Ma,rt,za,qt,Ge,Ae,it,qa,Wt,S,J,nt,ie,Wa,st,Ba,Bt,Se,Ra,Rt,N,O,lt,ne,Da,ot,La,Dt,Ne,Ce,Ja,Lt,C,j,ft,se,Oa,ut,ja,Jt,Te,xe,Fa,Ot,T,F,pt,le,Ka,ct,Qa,jt,He,Ie,Va,Ft,x,K,ht,oe,Xa,mt,Ya,Kt,Me,ze,dt,Za,Qt,H,Q,gt,fe,er,vt,tr,Vt,qe,ar,Xt,We,Be,rr,Yt,I,V,_t,ue,ir,Pt,nr,Zt,Re,sr,ea,De,lr,ta;return X=new E({}),Y=new E({}),q=new Mi({props:{$$slots:{default:[zi]},$$scope:{ctx:$t}}}),Z=new E({}),ee=new E({}),te=new E({}),ae=new E({}),re=new E({}),ie=new E({}),ne=new E({}),se=new E({}),le=new E({}),oe=new E({}),fe=new E({}),ue=new E({}),{c(){h=r("meta"),M=f(),m=r("h1"),w=r("a"),Le=r("span"),d(X.$$.fragment),da=f(),Je=r("span"),ga=p("Performance and Scalability"),Et=f(),ce=r("p"),va=p("Training larger and larger transformer models and deploying them to production comes with a range of challenges. During training your model can require more GPU memory than is available or be very slow to train and when you deploy it for inference it can be overwhelmed with the throughput that is required in the production environment. This documentation is designed to help you navigate these challenges and find the best setting for your use-case. We split the guides into training and inference as they come with different challenges and solutions. Then within each of them we have separate guides for different kinds of hardware setting (e.g. single vs. multi-GPU for training or CPU vs. GPU for infrence)."),wt=f(),he=r("p"),me=r("img"),bt=f(),de=r("p"),_a=p("This document serves as an overview and entry point for the methods that could be useful for your scenario."),yt=f(),b=r("h2"),z=r("a"),Oe=r("span"),d(Y.$$.fragment),Pa=f(),je=r("span"),$a=p("Training"),Ut=f(),ge=r("p"),Ea=p("Training transformer models efficiently requires an accelerator such as a GPU or TPU. The most common case is where you only have a single GPU, but there is also a section about multi-GPU and CPU training (with more coming soon)."),kt=f(),d(q.$$.fragment),Gt=f(),y=r("h3"),W=r("a"),Fe=r("span"),d(Z.$$.fragment),wa=f(),Ke=r("span"),ba=p("Single GPU"),At=f(),ve=r("p"),ya=p("Training large models on a single GPU can be challenging but there are a number of tools and methods that make it feasible. In this section methods such as mixed precision training, gradient accumulation and checkpointing, efficient optimizers, as well as strategies to determine the best batch size are discussed."),St=f(),_e=r("p"),Pe=r("a"),Ua=p("Go to single GPU training section"),Nt=f(),U=r("h3"),B=r("a"),Qe=r("span"),d(ee.$$.fragment),ka=f(),Ve=r("span"),Ga=p("Multi-GPU"),Ct=f(),$e=r("p"),Aa=p("In some cases training on a single GPU is still too slow or won\u2019t fit the large model. Moving to a multi-GPU setup is the logical step, but training on multiple GPUs at once comes with new decisions: does each GPU have a full copy of the model or is the model itself also distributed? In this section we look at data, tensor, and pipeline parallism."),Tt=f(),Ee=r("p"),we=r("a"),Sa=p("Go to multi-GPU training section"),xt=f(),k=r("h3"),R=r("a"),Xe=r("span"),d(te.$$.fragment),Na=f(),Ye=r("span"),Ca=p("CPU"),Ht=f(),be=r("p"),ye=r("a"),Ta=p("Go to CPU training section"),It=f(),G=r("h3"),D=r("a"),Ze=r("span"),d(ae.$$.fragment),xa=f(),et=r("span"),Ha=p("TPU"),Mt=f(),Ue=r("p"),ke=r("a"),tt=r("em"),Ia=p("Coming soon"),zt=f(),A=r("h3"),L=r("a"),at=r("span"),d(re.$$.fragment),Ma=f(),rt=r("span"),za=p("Specialized Hardware"),qt=f(),Ge=r("p"),Ae=r("a"),it=r("em"),qa=p("Coming soon"),Wt=f(),S=r("h2"),J=r("a"),nt=r("span"),d(ie.$$.fragment),Wa=f(),st=r("span"),Ba=p("Inference"),Bt=f(),Se=r("p"),Ra=p("Efficient inference with large models in a production environment can be as challenging as training them. In the following sections we go through the steps to run inference on CPU and single/multi-GPU setups."),Rt=f(),N=r("h3"),O=r("a"),lt=r("span"),d(ne.$$.fragment),Da=f(),ot=r("span"),La=p("CPU"),Dt=f(),Ne=r("p"),Ce=r("a"),Ja=p("Go to CPU inference section"),Lt=f(),C=r("h3"),j=r("a"),ft=r("span"),d(se.$$.fragment),Oa=f(),ut=r("span"),ja=p("Single GPU"),Jt=f(),Te=r("p"),xe=r("a"),Fa=p("Go to single GPU inference section"),Ot=f(),T=r("h3"),F=r("a"),pt=r("span"),d(le.$$.fragment),Ka=f(),ct=r("span"),Qa=p("Multi-GPU"),jt=f(),He=r("p"),Ie=r("a"),Va=p("Go to multi-GPU inference section"),Ft=f(),x=r("h3"),K=r("a"),ht=r("span"),d(oe.$$.fragment),Xa=f(),mt=r("span"),Ya=p("Specialized Hardware"),Kt=f(),Me=r("p"),ze=r("a"),dt=r("em"),Za=p("Coming soon"),Qt=f(),H=r("h2"),Q=r("a"),gt=r("span"),d(fe.$$.fragment),er=f(),vt=r("span"),tr=p("Hardware"),Vt=f(),qe=r("p"),ar=p("In the hardware section you can find tips and tricks when building your own deep learning rig."),Xt=f(),We=r("p"),Be=r("a"),rr=p("Go to hardware section"),Yt=f(),I=r("h2"),V=r("a"),_t=r("span"),d(ue.$$.fragment),ir=f(),Pt=r("span"),nr=p("Contribute"),Zt=f(),Re=r("p"),sr=p("This document is far from being complete and a lot more needs to be added, so if you have additions or corrections to make please don\u2019t hesitate to open a PR or if you aren\u2019t sure start an Issue and we can discuss the details there."),ea=f(),De=r("p"),lr=p("When making contributions that A is better than B, please try to include a reproducible benchmark and/or a link to the source of that information (unless it comes directly from you)."),this.h()},l(e){const s=xi('[data-svelte="svelte-1phssyn"]',document.head);h=i(s,"META",{name:!0,content:!0}),s.forEach(t),M=u(e),m=i(e,"H1",{class:!0});var pe=n(m);w=i(pe,"A",{id:!0,class:!0,href:!0});var fr=n(w);Le=i(fr,"SPAN",{});var ur=n(Le);g(X.$$.fragment,ur),ur.forEach(t),fr.forEach(t),da=u(pe),Je=i(pe,"SPAN",{});var pr=n(Je);ga=c(pr,"Performance and Scalability"),pr.forEach(t),pe.forEach(t),Et=u(e),ce=i(e,"P",{});var cr=n(ce);va=c(cr,"Training larger and larger transformer models and deploying them to production comes with a range of challenges. During training your model can require more GPU memory than is available or be very slow to train and when you deploy it for inference it can be overwhelmed with the throughput that is required in the production environment. This documentation is designed to help you navigate these challenges and find the best setting for your use-case. We split the guides into training and inference as they come with different challenges and solutions. Then within each of them we have separate guides for different kinds of hardware setting (e.g. single vs. multi-GPU for training or CPU vs. GPU for infrence)."),cr.forEach(t),wt=u(e),he=i(e,"P",{});var hr=n(he);me=i(hr,"IMG",{src:!0,alt:!0}),hr.forEach(t),bt=u(e),de=i(e,"P",{});var mr=n(de);_a=c(mr,"This document serves as an overview and entry point for the methods that could be useful for your scenario."),mr.forEach(t),yt=u(e),b=i(e,"H2",{class:!0});var aa=n(b);z=i(aa,"A",{id:!0,class:!0,href:!0});var dr=n(z);Oe=i(dr,"SPAN",{});var gr=n(Oe);g(Y.$$.fragment,gr),gr.forEach(t),dr.forEach(t),Pa=u(aa),je=i(aa,"SPAN",{});var vr=n(je);$a=c(vr,"Training"),vr.forEach(t),aa.forEach(t),Ut=u(e),ge=i(e,"P",{});var _r=n(ge);Ea=c(_r,"Training transformer models efficiently requires an accelerator such as a GPU or TPU. The most common case is where you only have a single GPU, but there is also a section about multi-GPU and CPU training (with more coming soon)."),_r.forEach(t),kt=u(e),g(q.$$.fragment,e),Gt=u(e),y=i(e,"H3",{class:!0});var ra=n(y);W=i(ra,"A",{id:!0,class:!0,href:!0});var Pr=n(W);Fe=i(Pr,"SPAN",{});var $r=n(Fe);g(Z.$$.fragment,$r),$r.forEach(t),Pr.forEach(t),wa=u(ra),Ke=i(ra,"SPAN",{});var Er=n(Ke);ba=c(Er,"Single GPU"),Er.forEach(t),ra.forEach(t),At=u(e),ve=i(e,"P",{});var wr=n(ve);ya=c(wr,"Training large models on a single GPU can be challenging but there are a number of tools and methods that make it feasible. In this section methods such as mixed precision training, gradient accumulation and checkpointing, efficient optimizers, as well as strategies to determine the best batch size are discussed."),wr.forEach(t),St=u(e),_e=i(e,"P",{});var br=n(_e);Pe=i(br,"A",{href:!0});var yr=n(Pe);Ua=c(yr,"Go to single GPU training section"),yr.forEach(t),br.forEach(t),Nt=u(e),U=i(e,"H3",{class:!0});var ia=n(U);B=i(ia,"A",{id:!0,class:!0,href:!0});var Ur=n(B);Qe=i(Ur,"SPAN",{});var kr=n(Qe);g(ee.$$.fragment,kr),kr.forEach(t),Ur.forEach(t),ka=u(ia),Ve=i(ia,"SPAN",{});var Gr=n(Ve);Ga=c(Gr,"Multi-GPU"),Gr.forEach(t),ia.forEach(t),Ct=u(e),$e=i(e,"P",{});var Ar=n($e);Aa=c(Ar,"In some cases training on a single GPU is still too slow or won\u2019t fit the large model. Moving to a multi-GPU setup is the logical step, but training on multiple GPUs at once comes with new decisions: does each GPU have a full copy of the model or is the model itself also distributed? In this section we look at data, tensor, and pipeline parallism."),Ar.forEach(t),Tt=u(e),Ee=i(e,"P",{});var Sr=n(Ee);we=i(Sr,"A",{href:!0});var Nr=n(we);Sa=c(Nr,"Go to multi-GPU training section"),Nr.forEach(t),Sr.forEach(t),xt=u(e),k=i(e,"H3",{class:!0});var na=n(k);R=i(na,"A",{id:!0,class:!0,href:!0});var Cr=n(R);Xe=i(Cr,"SPAN",{});var Tr=n(Xe);g(te.$$.fragment,Tr),Tr.forEach(t),Cr.forEach(t),Na=u(na),Ye=i(na,"SPAN",{});var xr=n(Ye);Ca=c(xr,"CPU"),xr.forEach(t),na.forEach(t),Ht=u(e),be=i(e,"P",{});var Hr=n(be);ye=i(Hr,"A",{href:!0});var Ir=n(ye);Ta=c(Ir,"Go to CPU training section"),Ir.forEach(t),Hr.forEach(t),It=u(e),G=i(e,"H3",{class:!0});var sa=n(G);D=i(sa,"A",{id:!0,class:!0,href:!0});var Mr=n(D);Ze=i(Mr,"SPAN",{});var zr=n(Ze);g(ae.$$.fragment,zr),zr.forEach(t),Mr.forEach(t),xa=u(sa),et=i(sa,"SPAN",{});var qr=n(et);Ha=c(qr,"TPU"),qr.forEach(t),sa.forEach(t),Mt=u(e),Ue=i(e,"P",{});var Wr=n(Ue);ke=i(Wr,"A",{href:!0});var Br=n(ke);tt=i(Br,"EM",{});var Rr=n(tt);Ia=c(Rr,"Coming soon"),Rr.forEach(t),Br.forEach(t),Wr.forEach(t),zt=u(e),A=i(e,"H3",{class:!0});var la=n(A);L=i(la,"A",{id:!0,class:!0,href:!0});var Dr=n(L);at=i(Dr,"SPAN",{});var Lr=n(at);g(re.$$.fragment,Lr),Lr.forEach(t),Dr.forEach(t),Ma=u(la),rt=i(la,"SPAN",{});var Jr=n(rt);za=c(Jr,"Specialized Hardware"),Jr.forEach(t),la.forEach(t),qt=u(e),Ge=i(e,"P",{});var Or=n(Ge);Ae=i(Or,"A",{href:!0});var jr=n(Ae);it=i(jr,"EM",{});var Fr=n(it);qa=c(Fr,"Coming soon"),Fr.forEach(t),jr.forEach(t),Or.forEach(t),Wt=u(e),S=i(e,"H2",{class:!0});var oa=n(S);J=i(oa,"A",{id:!0,class:!0,href:!0});var Kr=n(J);nt=i(Kr,"SPAN",{});var Qr=n(nt);g(ie.$$.fragment,Qr),Qr.forEach(t),Kr.forEach(t),Wa=u(oa),st=i(oa,"SPAN",{});var Vr=n(st);Ba=c(Vr,"Inference"),Vr.forEach(t),oa.forEach(t),Bt=u(e),Se=i(e,"P",{});var Xr=n(Se);Ra=c(Xr,"Efficient inference with large models in a production environment can be as challenging as training them. In the following sections we go through the steps to run inference on CPU and single/multi-GPU setups."),Xr.forEach(t),Rt=u(e),N=i(e,"H3",{class:!0});var fa=n(N);O=i(fa,"A",{id:!0,class:!0,href:!0});var Yr=n(O);lt=i(Yr,"SPAN",{});var Zr=n(lt);g(ne.$$.fragment,Zr),Zr.forEach(t),Yr.forEach(t),Da=u(fa),ot=i(fa,"SPAN",{});var ei=n(ot);La=c(ei,"CPU"),ei.forEach(t),fa.forEach(t),Dt=u(e),Ne=i(e,"P",{});var ti=n(Ne);Ce=i(ti,"A",{href:!0});var ai=n(Ce);Ja=c(ai,"Go to CPU inference section"),ai.forEach(t),ti.forEach(t),Lt=u(e),C=i(e,"H3",{class:!0});var ua=n(C);j=i(ua,"A",{id:!0,class:!0,href:!0});var ri=n(j);ft=i(ri,"SPAN",{});var ii=n(ft);g(se.$$.fragment,ii),ii.forEach(t),ri.forEach(t),Oa=u(ua),ut=i(ua,"SPAN",{});var ni=n(ut);ja=c(ni,"Single GPU"),ni.forEach(t),ua.forEach(t),Jt=u(e),Te=i(e,"P",{});var si=n(Te);xe=i(si,"A",{href:!0});var li=n(xe);Fa=c(li,"Go to single GPU inference section"),li.forEach(t),si.forEach(t),Ot=u(e),T=i(e,"H3",{class:!0});var pa=n(T);F=i(pa,"A",{id:!0,class:!0,href:!0});var oi=n(F);pt=i(oi,"SPAN",{});var fi=n(pt);g(le.$$.fragment,fi),fi.forEach(t),oi.forEach(t),Ka=u(pa),ct=i(pa,"SPAN",{});var ui=n(ct);Qa=c(ui,"Multi-GPU"),ui.forEach(t),pa.forEach(t),jt=u(e),He=i(e,"P",{});var pi=n(He);Ie=i(pi,"A",{href:!0});var ci=n(Ie);Va=c(ci,"Go to multi-GPU inference section"),ci.forEach(t),pi.forEach(t),Ft=u(e),x=i(e,"H3",{class:!0});var ca=n(x);K=i(ca,"A",{id:!0,class:!0,href:!0});var hi=n(K);ht=i(hi,"SPAN",{});var mi=n(ht);g(oe.$$.fragment,mi),mi.forEach(t),hi.forEach(t),Xa=u(ca),mt=i(ca,"SPAN",{});var di=n(mt);Ya=c(di,"Specialized Hardware"),di.forEach(t),ca.forEach(t),Kt=u(e),Me=i(e,"P",{});var gi=n(Me);ze=i(gi,"A",{href:!0});var vi=n(ze);dt=i(vi,"EM",{});var _i=n(dt);Za=c(_i,"Coming soon"),_i.forEach(t),vi.forEach(t),gi.forEach(t),Qt=u(e),H=i(e,"H2",{class:!0});var ha=n(H);Q=i(ha,"A",{id:!0,class:!0,href:!0});var Pi=n(Q);gt=i(Pi,"SPAN",{});var $i=n(gt);g(fe.$$.fragment,$i),$i.forEach(t),Pi.forEach(t),er=u(ha),vt=i(ha,"SPAN",{});var Ei=n(vt);tr=c(Ei,"Hardware"),Ei.forEach(t),ha.forEach(t),Vt=u(e),qe=i(e,"P",{});var wi=n(qe);ar=c(wi,"In the hardware section you can find tips and tricks when building your own deep learning rig."),wi.forEach(t),Xt=u(e),We=i(e,"P",{});var bi=n(We);Be=i(bi,"A",{href:!0});var yi=n(Be);rr=c(yi,"Go to hardware section"),yi.forEach(t),bi.forEach(t),Yt=u(e),I=i(e,"H2",{class:!0});var ma=n(I);V=i(ma,"A",{id:!0,class:!0,href:!0});var Ui=n(V);_t=i(Ui,"SPAN",{});var ki=n(_t);g(ue.$$.fragment,ki),ki.forEach(t),Ui.forEach(t),ir=u(ma),Pt=i(ma,"SPAN",{});var Gi=n(Pt);nr=c(Gi,"Contribute"),Gi.forEach(t),ma.forEach(t),Zt=u(e),Re=i(e,"P",{});var Ai=n(Re);sr=c(Ai,"This document is far from being complete and a lot more needs to be added, so if you have additions or corrections to make please don\u2019t hesitate to open a PR or if you aren\u2019t sure start an Issue and we can discuss the details there."),Ai.forEach(t),ea=u(e),De=i(e,"P",{});var Si=n(De);lr=c(Si,"When making contributions that A is better than B, please try to include a reproducible benchmark and/or a link to the source of that information (unless it comes directly from you)."),Si.forEach(t),this.h()},h(){l(h,"name","hf:doc:metadata"),l(h,"content",JSON.stringify(Wi)),l(w,"id","performance-and-scalability"),l(w,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(w,"href","#performance-and-scalability"),l(m,"class","relative group"),Hi(me.src,or="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/perf_overview.png")||l(me,"src",or),l(me,"alt","perf_overview"),l(z,"id","training"),l(z,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(z,"href","#training"),l(b,"class","relative group"),l(W,"id","single-gpu"),l(W,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(W,"href","#single-gpu"),l(y,"class","relative group"),l(Pe,"href","perf_train_gpu_one"),l(B,"id","multigpu"),l(B,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(B,"href","#multigpu"),l(U,"class","relative group"),l(we,"href","perf_train_gpu_many"),l(R,"id","cpu"),l(R,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(R,"href","#cpu"),l(k,"class","relative group"),l(ye,"href","perf_train_cpu"),l(D,"id","tpu"),l(D,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(D,"href","#tpu"),l(G,"class","relative group"),l(ke,"href","perf_train_tpu"),l(L,"id","specialized-hardware"),l(L,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(L,"href","#specialized-hardware"),l(A,"class","relative group"),l(Ae,"href","perf_train_special"),l(J,"id","inference"),l(J,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(J,"href","#inference"),l(S,"class","relative group"),l(O,"id","cpu"),l(O,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(O,"href","#cpu"),l(N,"class","relative group"),l(Ce,"href","perf_infer_cpu"),l(j,"id","single-gpu"),l(j,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(j,"href","#single-gpu"),l(C,"class","relative group"),l(xe,"href","perf_infer_gpu_one"),l(F,"id","multigpu"),l(F,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(F,"href","#multigpu"),l(T,"class","relative group"),l(Ie,"href","perf_infer_gpu_many"),l(K,"id","specialized-hardware"),l(K,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(K,"href","#specialized-hardware"),l(x,"class","relative group"),l(ze,"href","perf_infer_special"),l(Q,"id","hardware"),l(Q,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(Q,"href","#hardware"),l(H,"class","relative group"),l(Be,"href","perf_hardware"),l(V,"id","contribute"),l(V,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),l(V,"href","#contribute"),l(I,"class","relative group")},m(e,s){a(document.head,h),o(e,M,s),o(e,m,s),a(m,w),a(w,Le),v(X,Le,null),a(m,da),a(m,Je),a(Je,ga),o(e,Et,s),o(e,ce,s),a(ce,va),o(e,wt,s),o(e,he,s),a(he,me),o(e,bt,s),o(e,de,s),a(de,_a),o(e,yt,s),o(e,b,s),a(b,z),a(z,Oe),v(Y,Oe,null),a(b,Pa),a(b,je),a(je,$a),o(e,Ut,s),o(e,ge,s),a(ge,Ea),o(e,kt,s),v(q,e,s),o(e,Gt,s),o(e,y,s),a(y,W),a(W,Fe),v(Z,Fe,null),a(y,wa),a(y,Ke),a(Ke,ba),o(e,At,s),o(e,ve,s),a(ve,ya),o(e,St,s),o(e,_e,s),a(_e,Pe),a(Pe,Ua),o(e,Nt,s),o(e,U,s),a(U,B),a(B,Qe),v(ee,Qe,null),a(U,ka),a(U,Ve),a(Ve,Ga),o(e,Ct,s),o(e,$e,s),a($e,Aa),o(e,Tt,s),o(e,Ee,s),a(Ee,we),a(we,Sa),o(e,xt,s),o(e,k,s),a(k,R),a(R,Xe),v(te,Xe,null),a(k,Na),a(k,Ye),a(Ye,Ca),o(e,Ht,s),o(e,be,s),a(be,ye),a(ye,Ta),o(e,It,s),o(e,G,s),a(G,D),a(D,Ze),v(ae,Ze,null),a(G,xa),a(G,et),a(et,Ha),o(e,Mt,s),o(e,Ue,s),a(Ue,ke),a(ke,tt),a(tt,Ia),o(e,zt,s),o(e,A,s),a(A,L),a(L,at),v(re,at,null),a(A,Ma),a(A,rt),a(rt,za),o(e,qt,s),o(e,Ge,s),a(Ge,Ae),a(Ae,it),a(it,qa),o(e,Wt,s),o(e,S,s),a(S,J),a(J,nt),v(ie,nt,null),a(S,Wa),a(S,st),a(st,Ba),o(e,Bt,s),o(e,Se,s),a(Se,Ra),o(e,Rt,s),o(e,N,s),a(N,O),a(O,lt),v(ne,lt,null),a(N,Da),a(N,ot),a(ot,La),o(e,Dt,s),o(e,Ne,s),a(Ne,Ce),a(Ce,Ja),o(e,Lt,s),o(e,C,s),a(C,j),a(j,ft),v(se,ft,null),a(C,Oa),a(C,ut),a(ut,ja),o(e,Jt,s),o(e,Te,s),a(Te,xe),a(xe,Fa),o(e,Ot,s),o(e,T,s),a(T,F),a(F,pt),v(le,pt,null),a(T,Ka),a(T,ct),a(ct,Qa),o(e,jt,s),o(e,He,s),a(He,Ie),a(Ie,Va),o(e,Ft,s),o(e,x,s),a(x,K),a(K,ht),v(oe,ht,null),a(x,Xa),a(x,mt),a(mt,Ya),o(e,Kt,s),o(e,Me,s),a(Me,ze),a(ze,dt),a(dt,Za),o(e,Qt,s),o(e,H,s),a(H,Q),a(Q,gt),v(fe,gt,null),a(H,er),a(H,vt),a(vt,tr),o(e,Vt,s),o(e,qe,s),a(qe,ar),o(e,Xt,s),o(e,We,s),a(We,Be),a(Be,rr),o(e,Yt,s),o(e,I,s),a(I,V),a(V,_t),v(ue,_t,null),a(I,ir),a(I,Pt),a(Pt,nr),o(e,Zt,s),o(e,Re,s),a(Re,sr),o(e,ea,s),o(e,De,s),a(De,lr),ta=!0},p(e,[s]){const pe={};s&2&&(pe.$$scope={dirty:s,ctx:e}),q.$set(pe)},i(e){ta||(_(X.$$.fragment,e),_(Y.$$.fragment,e),_(q.$$.fragment,e),_(Z.$$.fragment,e),_(ee.$$.fragment,e),_(te.$$.fragment,e),_(ae.$$.fragment,e),_(re.$$.fragment,e),_(ie.$$.fragment,e),_(ne.$$.fragment,e),_(se.$$.fragment,e),_(le.$$.fragment,e),_(oe.$$.fragment,e),_(fe.$$.fragment,e),_(ue.$$.fragment,e),ta=!0)},o(e){P(X.$$.fragment,e),P(Y.$$.fragment,e),P(q.$$.fragment,e),P(Z.$$.fragment,e),P(ee.$$.fragment,e),P(te.$$.fragment,e),P(ae.$$.fragment,e),P(re.$$.fragment,e),P(ie.$$.fragment,e),P(ne.$$.fragment,e),P(se.$$.fragment,e),P(le.$$.fragment,e),P(oe.$$.fragment,e),P(fe.$$.fragment,e),P(ue.$$.fragment,e),ta=!1},d(e){t(h),e&&t(M),e&&t(m),$(X),e&&t(Et),e&&t(ce),e&&t(wt),e&&t(he),e&&t(bt),e&&t(de),e&&t(yt),e&&t(b),$(Y),e&&t(Ut),e&&t(ge),e&&t(kt),$(q,e),e&&t(Gt),e&&t(y),$(Z),e&&t(At),e&&t(ve),e&&t(St),e&&t(_e),e&&t(Nt),e&&t(U),$(ee),e&&t(Ct),e&&t($e),e&&t(Tt),e&&t(Ee),e&&t(xt),e&&t(k),$(te),e&&t(Ht),e&&t(be),e&&t(It),e&&t(G),$(ae),e&&t(Mt),e&&t(Ue),e&&t(zt),e&&t(A),$(re),e&&t(qt),e&&t(Ge),e&&t(Wt),e&&t(S),$(ie),e&&t(Bt),e&&t(Se),e&&t(Rt),e&&t(N),$(ne),e&&t(Dt),e&&t(Ne),e&&t(Lt),e&&t(C),$(se),e&&t(Jt),e&&t(Te),e&&t(Ot),e&&t(T),$(le),e&&t(jt),e&&t(He),e&&t(Ft),e&&t(x),$(oe),e&&t(Kt),e&&t(Me),e&&t(Qt),e&&t(H),$(fe),e&&t(Vt),e&&t(qe),e&&t(Xt),e&&t(We),e&&t(Yt),e&&t(I),$(ue),e&&t(Zt),e&&t(Re),e&&t(ea),e&&t(De)}}}const Wi={local:"performance-and-scalability",sections:[{local:"training",sections:[{local:"single-gpu",title:"Single GPU"},{local:"multigpu",title:"Multi-GPU"},{local:"cpu",title:"CPU"},{local:"tpu",title:"TPU"},{local:"specialized-hardware",title:"Specialized Hardware"}],title:"Training"},{local:"inference",sections:[{local:"cpu",title:"CPU"},{local:"single-gpu",title:"Single GPU"},{local:"multigpu",title:"Multi-GPU"},{local:"specialized-hardware",title:"Specialized Hardware"}],title:"Inference"},{local:"hardware",title:"Hardware"},{local:"contribute",title:"Contribute"}],title:"Performance and Scalability"};function Bi($t){return Ii(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ji extends Ni{constructor(h){super();Ci(this,h,Bi,qi,Ti,{})}}export{Ji as default,Wi as metadata};
